package net.pingex.discordbot;

import sx.blah.discord.api.IDiscordClient;
import sx.blah.discord.handle.impl.events.MessageReceivedEvent;

import java.util.HashMap;

/**
 * Internal commands of the bot, such as `help`, and so on
 * @version 0.1-dev
 * @author Raphael "Pingex" NAAS
 */
@Controllable(name="internal")
class InternalCommandsModule extends AbstractModule
{
	/**
	 * Constructor doing all the basic stuff, like registering as a Listener to Discord, getting a logger, etc.
	 * @param client Discord Client instance used to register self.
	 */
	public InternalCommandsModule(IDiscordClient client)
	{
		super(client);
	}

	/**
	 * Scans and print the usage of a command
	 * @param command Full command, ie `module:command`
	 * @return The man of this command
	 */
	@Command(shorthand = "help")
	public String help(MessageReceivedEvent event, String command)
	{
		if(!command.contains(":") && CommandDispatcher.getInstance().getShortList().containsKey(command))
			command = CommandDispatcher.getInstance().getShortList().get(command.toLowerCase());
		else
			command = command.toLowerCase();

		if(!CommandDispatcher.getInstance().getCommandList().containsKey(command)) return "No help available for this command.";
		InvokableMethod matchingMethod = CommandDispatcher.getInstance().getCommandList().get(command);

		StringBuffer toReturn = new StringBuffer("Usage: ");
		toReturn.append((Configuration.exists("general", "commandPrefix") ? Configuration.getValue("general", "commandPrefix") : "!") + command + " ");
		for(int i=1; i<matchingMethod.getMethod().getParameterCount(); i++)
			toReturn.append(matchingMethod.getMethod().getParameterTypes()[i].getName() + " ");

		return toReturn.toString();
	}
}
